/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Controller;

import Dao.ChequePostingDao;
import DataEntryBean.ChequeDetailsBean;
import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author 1004242
 */
public class ChequePostingServlet extends HttpServlet{
  @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession(false);
        String pacsId = (String) session.getAttribute("pacsId");
        String tellerId = (String)session.getAttribute("user");
       // String selectedTab = request.getParameter("selectedTab");
        ChequePostingDao cpDao = new ChequePostingDao();
        String result = null;
        ArrayList<ChequeDetailsBean> allChequeList = null;

        try{
            if(selectedTab.equalsIgnoreCase("ChequePosting")){
           // String accNo = request.getParameter("accNo");
            //String chqDate = request.getParameter("chqDt");
            //String chqNo = request.getParameter("chqNo");
           // Double amount = Double.parseDouble(request.getParameter("chqAmt"));
            //String chqbank = request.getParameter("chqBnk");
            result = cpDao.PostChequeProc(tellerId, pacsId, accNo, chqNo, chqDate, amount, chqbank);

            request.setAttribute("message1", result);
            request.setAttribute("toggleTab", selectedTab);
            request.getRequestDispatcher("/Deposit/ChequePosting.jsp").forward(request, response);
            
            } else if (selectedTab.equalsIgnoreCase("ChequeEnquiry")) {
               // String accNoEnq = request.getParameter("accNoEnq");
                allChequeList = cpDao.getChequedetails(pacsId, accNoEnq);
                 if ( allChequeList !=null && allChequeList.size() > 0) {
                     request.setAttribute("allcheque", allChequeList);
                     request.setAttribute("accNo", accNoEnq);
                     request.setAttribute("toggleTab", selectedTab);
                }
                 else
                 {
                     request.setAttribute("allcheque", null);
                     request.setAttribute("toggleTab", selectedTab);
                     request.setAttribute("message2", "No details found");
                 }

                request.getRequestDispatcher("/Deposit/ChequePosting.jsp").forward(request, response);
            
            } else if (selectedTab.equalsIgnoreCase("ChequeEnquiryProcess")) {
                String indicator = request.getParameter("indicator");
                //String accNoEnq = request.getParameter("accNoEnq");
               // String chqno = request.getParameter("ChqNO"+indicator);
                Double comsn = 0.0;
                //String commission = request.getParameter("commission"+indicator);
                if(commission.isEmpty() || commission == null)
                {
                    comsn = 0.0;
                }
                else
                {
                    comsn = Double.valueOf(commission);
                }
               // String action = request.getParameter("action"+indicator);
               // String narration = request.getParameter("narration"+indicator);
                String result2 = cpDao.ProcessChequeProc(tellerId,  pacsId,  accNoEnq,  chqno, comsn ,  action,narration);

                     request.setAttribute("message2", result2);
                     request.setAttribute("toggleTab", "ChequeEnquiry");
               
                request.getRequestDispatcher("/Deposit/ChequePosting.jsp").forward(request, response);
            }
    
        } catch (Exception e) {
           // e.printStackTrace();
           System.out.println("Error occurred during processing.");
            if (selectedTab.equalsIgnoreCase("CHEQUE ENQUIRY")) {
                request.setAttribute("message2", "Request can not be processed.");
            } else {
                request.setAttribute("message1", "Request can not be processed.");
            }
//            request.setAttribute("toggleTab", selectedTab);
//            request.getRequestDispatcher("/Deposit/ChequePosting.jsp").forward(request, response);
        
        } finally {
                System.out.println("Processing done.");
        }

    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */

    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
